diff --git a/src/corelibs/U2View/src/ov_msa/MSAEditorOffsetsView.h b/src/corelibs/U2View/src/ov_msa/MSAEditorOffsetsView.h
index 7a2df14432..03306fa816 100644
--- a/src/corelibs/U2View/src/ov_msa/MSAEditorOffsetsView.h
+++ b/src/corelibs/U2View/src/ov_msa/MSAEditorOffsetsView.h
@@ -35,7 +35,7 @@ class MaEditorSequenceArea;
 class MaModificationInfo;
 class MultipleSequenceAlignmentObject;
 
-class U2VIEW_EXPORT MSAEditorOffsetsViewController : public QObject {
+class U2VIEW_EXPORT MSAEditorOffsetsViewController : public QObject { // MSAEditorOffsetsViewController -> MaEditorOffsetsViewController
     Q_OBJECT
 public:
     MSAEditorOffsetsViewController(MaEditorWgt *maEditorUi, MaEditor *editor, MaEditorSequenceArea *seqArea);
@@ -72,7 +72,7 @@ protected:
     void paintEvent(QPaintEvent *e);
     void updateView();
     void drawAll(QPainter &p);
-    QFont getOffsetsFont();
+    QFont getOffsetsFont();// -> MSAEditorOffsetsViewController
     void drawRefSequence(QPainter &p, const QRect &r);
 
 private:
diff --git a/src/corelibs/U2View/src/ov_msa/MSAEditorSequenceArea.h b/src/corelibs/U2View/src/ov_msa/MSAEditorSequenceArea.h
index 3eb9a5101e..cf0dc616ce 100644
--- a/src/corelibs/U2View/src/ov_msa/MSAEditorSequenceArea.h
+++ b/src/corelibs/U2View/src/ov_msa/MSAEditorSequenceArea.h
@@ -190,18 +190,18 @@ private:
 
     void updateCollapseModel(const MaModificationInfo &modInfo) override;
 
-    QAction *delColAction;
-    QAction *removeAllGapsAction;
-
-    QAction *createSubaligniment;
-    QAction *saveSequence;
-    QAction *addSeqFromFileAction;
-    QAction *addSeqFromProjectAction;
-    QAction *collapseModeSwitchAction;
-    QAction *collapseModeUpdateAction;
-    QAction *reverseComplementAction;
-    QAction *reverseAction;
-    QAction *complementAction;
+    QAction *delColAction;// -> MsaEditor
+    QAction *removeAllGapsAction;// -> MsaEditor
+
+    QAction *createSubaligniment;// -> MsaEditor
+    QAction *saveSequence;// -> MsaEditor
+    QAction *addSeqFromFileAction;// -> MsaEditor
+    QAction *addSeqFromProjectAction;// -> MsaEditor
+    QAction *collapseModeSwitchAction;// -> MsaEditor
+    QAction *collapseModeUpdateAction;// -> MsaEditor
+    QAction *reverseComplementAction;// -> MsaEditor
+    QAction *reverseAction;// -> MsaEditor
+    QAction *complementAction;// -> MsaEditor
 };
 
 // SANGER_TODO: move to EditorTasks?
diff --git a/src/corelibs/U2View/src/ov_msa/MaEditorNameList.h b/src/corelibs/U2View/src/ov_msa/MaEditorNameList.h
index 5266f54e3d..c3409b4d09 100644
--- a/src/corelibs/U2View/src/ov_msa/MaEditorNameList.h
+++ b/src/corelibs/U2View/src/ov_msa/MaEditorNameList.h
@@ -157,31 +157,32 @@ protected:
 
     virtual int getAvailableWidth() const;
 
+    //Ðàçäåëèòü íà MaEditorNameList (Widget) è Controller
     QObject *labels;    // used in GUI tests
     MaEditorWgt *ui;
     QScrollBar *nhBar;
-    QPoint mousePressPoint;
-    bool dragging;
-    GroupColorSchema groupColors;
+    QPoint mousePressPoint;// -> Controller
+    bool dragging;// -> Controller
+    GroupColorSchema groupColors;// èíòåãðàöèÿ ñ äåðåâüÿìè -> MaEditor
 
     QRubberBand *rubberBand;
 
 public:
-    QAction *editSequenceNameAction;
-    QAction *copyCurrentSequenceAction;
-    QAction *removeSequenceAction;
+    QAction *editSequenceNameAction;// -> Controller
+    QAction *copyCurrentSequenceAction;// -> Controller
+    QAction *removeSequenceAction;// -> Controller
 
 protected:
     QPixmap *cachedView;
 
-    MsaEditorUserModStepController *changeTracker;
-    int maVersionBeforeMousePress;
+    MsaEditorUserModStepController *changeTracker;//-> MaEditor
+    int maVersionBeforeMousePress;// -> Controller
 
-    static const int CROSS_SIZE = 9;
-    static const int CHILDREN_OFFSET = 8;
-    static const int MARGIN_TEXT_LEFT = 5;
-    static const int MARGIN_TEXT_TOP = 2;
-    static const int MARGIN_TEXT_BOTTOM = 2;
+    static const int CROSS_SIZE = 9;// -> Controller
+    static const int CHILDREN_OFFSET = 8;// -> Controller
+    static const int MARGIN_TEXT_LEFT = 5;// -> Controller
+    static const int MARGIN_TEXT_TOP = 2;// -> Controller
+    static const int MARGIN_TEXT_BOTTOM = 2;// -> Controller
 
 protected:
     MaEditor *editor;
diff --git a/src/corelibs/U2View/src/ov_msa/McaEditorConsensusArea.h b/src/corelibs/U2View/src/ov_msa/McaEditorConsensusArea.h
index d629301616..a6deaf0846 100644
--- a/src/corelibs/U2View/src/ov_msa/McaEditorConsensusArea.h
+++ b/src/corelibs/U2View/src/ov_msa/McaEditorConsensusArea.h
@@ -56,7 +56,7 @@ protected:
     QString getLastUsedAlgoSettingsKey() const override;
 
 private:
-    MaConsensusMismatchController *mismatchController;
+    MaConsensusMismatchController *mismatchController;// -> Controller èëè McaEditor? äîëæåí èäòè âìåñòå ñ consensusCache
 };
 
 }    // namespace U2
diff --git a/src/corelibs/U2View/src/ov_msa/McaEditorSequenceArea.h b/src/corelibs/U2View/src/ov_msa/McaEditorSequenceArea.h
index caefce358a..f551ebb207 100644
--- a/src/corelibs/U2View/src/ov_msa/McaEditorSequenceArea.h
+++ b/src/corelibs/U2View/src/ov_msa/McaEditorSequenceArea.h
@@ -121,20 +121,20 @@ private:
 
     void updateTrimActions(bool isEnabled);
 
-    ChromatogramViewSettings settings;
-    MaAmbiguousCharactersController *ambiguousCharactersController;
-
-    QAction *showQVAction;
-    QAction *showAllTraces;
-    QMenu *traceActionsMenu;
-    ScaleBar *scaleBar;
-    QAction *scaleAction;
-
-    QAction *insertAction;
-    QAction *removeGapBeforeSelectionAction;
-    QAction *removeColumnsOfGapsAction;
-    QAction *trimLeftEndAction;
-    QAction *trimRightEndAction;
+    ChromatogramViewSettings settings;// -> McaEditor
+    MaAmbiguousCharactersController *ambiguousCharactersController;// -> McaEditor
+
+    QAction *showQVAction;// -> McaEditor
+    QAction *showAllTraces;// -> McaEditor
+    QMenu *traceActionsMenu;// -> McaEditor
+    ScaleBar *scaleBar;// -> McaEditor
+    QAction *scaleAction;// -> McaEditor
+
+    QAction *insertAction;// -> McaEditor èëè Controller?
+    QAction *removeGapBeforeSelectionAction;// -> McaEditor èëè Controller?
+    QAction *removeColumnsOfGapsAction;// -> McaEditor èëè Controller?
+    QAction *trimLeftEndAction;// -> McaEditor èëè Controller?
+    QAction *trimRightEndAction;// -> McaEditor èëè Controller?
 };
 
 }    // namespace U2
diff --git a/src/corelibs/U2View/src/ov_msa/MsaEditorWgt.h b/src/corelibs/U2View/src/ov_msa/MsaEditorWgt.h
index 2278ecb506..900dc5989a 100644
--- a/src/corelibs/U2View/src/ov_msa/MsaEditorWgt.h
+++ b/src/corelibs/U2View/src/ov_msa/MsaEditorWgt.h
@@ -80,9 +80,9 @@ protected:
 
 private:
     MsaEditorSimilarityColumn *dataList;
-    MSAEditorMultiTreeViewer *multiTreeViewer;
+    MSAEditorMultiTreeViewer *multiTreeViewer;//Ïåðåíåñòè â àáñòðàêòíîãî ïðåäêà MSA single line È MSA Multi line
     MsaEditorAlignmentDependentWidget *similarityStatistics;
-    MSAEditorTreeViewer *treeViewer;
+    MSAEditorTreeViewer *treeViewer;//Óäàëèòü
 };
 
 }    // namespace U2
diff --git a/src/corelibs/U2View/src/ov_msa/helpers/MaAmbiguousCharactersController.h b/src/corelibs/U2View/src/ov_msa/helpers/MaAmbiguousCharactersController.h
index f7c997b489..b340f77d6a 100644
--- a/src/corelibs/U2View/src/ov_msa/helpers/MaAmbiguousCharactersController.h
+++ b/src/corelibs/U2View/src/ov_msa/helpers/MaAmbiguousCharactersController.h
@@ -54,7 +54,7 @@ private:
     void prepareIterator(NavigationDirection direction, const QPoint &startPosition) const;
 
     MaEditor *maEditor;
-    MaEditorWgt *maEditorWgt;
+    MaEditorWgt *maEditorWgt; //Áóäåò íå íóæåí
 
     QAction *nextAction;
     QAction *previousAction;
diff --git a/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorConsensusArea.h b/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorConsensusArea.h
index c83d1519de..ac77dd897f 100644
--- a/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorConsensusArea.h
+++ b/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorConsensusArea.h
@@ -127,15 +127,15 @@ protected:
 
     MaEditor *editor;
     MaEditorWgt *ui;
-    QFont rulerFont;
-    QAction *configureConsensusAction;
-    int curPos;
-    bool selecting;
+    QFont rulerFont;// -> Controller
+    QAction *configureConsensusAction;// -> Controller
+    int curPos;// -> Controller
+    bool selecting;// -> Controller
 
-    MaEditorConsensusAreaSettings consensusSettings;
+    MaEditorConsensusAreaSettings consensusSettings;// -> Controller èëè MaEditor?
     MaConsensusAreaRenderer *renderer;
 
-    QSharedPointer<MSAEditorConsensusCache> consensusCache;
+    QSharedPointer<MSAEditorConsensusCache> consensusCache;// -> Controller èëè MaEditor?
 
     bool completeRedraw;
     QPixmap *cachedView;
diff --git a/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorSequenceArea.h b/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorSequenceArea.h
index e8bd37f094..9425d5edb6 100644
--- a/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorSequenceArea.h
+++ b/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorSequenceArea.h
@@ -294,67 +294,68 @@ protected:
     MaEditor *editor;
     MaEditorWgt *ui;
 
-    MsaColorScheme *colorScheme;
-    MsaHighlightingScheme *highlightingScheme;
+    //Ðàçäåëèòü íà MaEditorSequenceArea (Widget) è Controller äëÿ SequenceArea.
+    MsaColorScheme *colorScheme;// -> MaEditor
+    MsaHighlightingScheme *highlightingScheme;// -> MaEditor
 
-    GScrollBar *shBar;
+    GScrollBar *shBar;// -> MaEditorWgt ? (îñòàåòñÿ çäåñü) ïðèõîäÿò ïî óêàçàòåëþ, à íå ñîçäàþòñÿ òóò
     GScrollBar *svBar;
     QRubberBand *rubberBand;
-    bool showRubberBandOnSelection;
+    bool showRubberBandOnSelection;// -> Controller
 
-    SequenceAreaRenderer *renderer;
+    SequenceAreaRenderer *renderer;// -> Controller èëè îñòàâèòü òóò
 
     QPixmap *cachedView;
     bool completeRedraw;
 
-    MaMode maMode;
-    QTimer editModeAnimationTimer;
-    QColor selectionColor;
+    MaMode maMode;// -> Controller
+    QTimer editModeAnimationTimer;// -> Controller
+    QColor selectionColor;// -> Controller
 
-    bool editingEnabled;
-    bool shifting;
-    bool selecting;
-    Qt::MouseButton prevPressedButton;
+    bool editingEnabled;// -> Controller
+    bool shifting;// -> Controller
+    bool selecting;// -> Controller
+    Qt::MouseButton prevPressedButton;// -> Controller
 
     /* Last mouse press point. Global window coordinates. */
-    QPoint mousePressEventPoint;
+    QPoint mousePressEventPoint;// -> Controller
     /*
      * Last mouse press point in view rows/columns coordinates.
      * May be out of range if clicked out of the view/rows range.
      */
-    QPoint mousePressViewPos;
+    QPoint mousePressViewPos;// -> Controller
 
     /** Current selection with view rows/column coordinates. */
-    MaEditorSelection selection;
+    MaEditorSelection selection;// -> MaEditor
 
     /** Selected MA row ids within the current view selection. */
-    QList<qint64> selectedMaRowIds;
+    QList<qint64> selectedMaRowIds;// -> MaEditor
 
     /** Selected MA row columns within the current view selection. */
-    U2Region selectedColumns;
+    U2Region selectedColumns;// -> MaEditor
 
-    int maVersionBeforeShifting;
-    SelectionModificationHelper::MovableSide movableBorder;
+    int maVersionBeforeShifting;// -> Controller
+    SelectionModificationHelper::MovableSide movableBorder;// -> Controller
 
-    QList<U2MsaGap> ctrlModeGapModel;
-    qint64 lengthOnMousePress;
+    QList<U2MsaGap> ctrlModeGapModel;// -> Controller
+    qint64 lengthOnMousePress;// -> Controller
 
-    QAction *replaceCharacterAction;
-    QAction *fillWithGapsinsSymAction;
+    QAction *replaceCharacterAction;//-> Controller èëè MaEditor?
+    QAction *fillWithGapsinsSymAction;//-> Controller èëè MaEditor?
 
 public:
-    QAction *useDotsAction;
+    QAction *useDotsAction;//-> MaEditor
 
-    QList<QAction *> colorSchemeMenuActions;
-    QList<QAction *> customColorSchemeMenuActions;
-    QList<QAction *> highlightingSchemeMenuActions;
+    QList<QAction *> colorSchemeMenuActions;//-> MaEditor
+    QList<QAction *> customColorSchemeMenuActions;//-> MaEditor
+    QList<QAction *> highlightingSchemeMenuActions;//-> MaEditor
 
 protected:
     // The member is intended for tracking MSA changes (handling U2UseCommonUserModStep objects)
     // that does not fit into one method, e.g. shifting MSA region with mouse.
     // If the changing action fits within one method it's recommended using
     // the U2UseCommonUserModStep object explicitly.
-    MsaEditorUserModStepController changeTracker;
+    MsaEditorUserModStepController changeTracker;//-> MaEditor
 
     static const QChar emDash;
 };
diff --git a/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorWgt.h b/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorWgt.h
index 832c02a9d9..6d0e45991b 100644
--- a/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorWgt.h
+++ b/src/corelibs/U2View/src/ov_msa/view_rendering/MaEditorWgt.h
@@ -161,8 +161,8 @@ protected:
     virtual void initStatusBar() = 0;
 
 protected:
-    MaEditor *editor;
-    MaEditorSequenceArea *sequenceArea;
+    MaEditor *editor;//Ñäåëàòü íåçàâèñèìûì îò MaEditorWgt?
+    MaEditorSequenceArea *sequenceArea;//selection -> MaEditor
     MaEditorNameList *nameList;
     MaEditorConsensusArea *consensusArea;
     MaEditorOverviewArea *overviewArea;
@@ -177,18 +177,18 @@ protected:
     QVBoxLayout *nameAreaLayout;
     MaSplitterController maSplitter;
 
-    MsaUndoRedoFramework *undoFWK;
+    MsaUndoRedoFramework *undoFWK;// -> MaEditor
 
-    MaCollapseModel *collapseModel;
-    bool collapsibleMode;
-    bool enableCollapsingOfSingleRowGroups;
+    MaCollapseModel *collapseModel;// -> MaEditor
+    bool collapsibleMode;// -> MaEditor
+    bool enableCollapsingOfSingleRowGroups;// -> MaEditor
     ScrollController *scrollController;
     BaseWidthController *baseWidthController;
     RowHeightController *rowHeightController;
     DrawHelper *drawHelper;
 
 public:
-    QAction *delSelectionAction;
+    QAction *delSelectionAction;// -> MaEditor?
     QAction *copySelectionAction;
     QAction *copyFormattedSelectionAction;
     QAction *pasteAction;
